//
//  AppDelegate.m
//  DrawingX2
//
//  Created by Masayuki Nii on 09/06/01.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "AppDelegate.h"

@implementation AppDelegate

- (id)init
{
	id initObj = [super init];
	nums = nil;
	return initObj;
}

- (void)goDrawing:(id) sender	
{
	NSNumber *thisNumber = [nums objectAtIndex: seq];
	[resultNumber setStringValue: [thisNumber stringValue]];
	[pastNumbers setStringValue: [NSString stringWithFormat: @"%@ %d", [pastNumbers stringValue],[thisNumber intValue]]];
	
	seq++;
	if(seq>=maxOfSeq)	{
		[pastNumbers setStringValue: [NSString stringWithFormat: @"%@ - Finish", [pastNumbers stringValue]]];
		[drawingButton setEnabled: NO];
	}
}

- (void)insertNextLine:(id) sender 
{
	[pastNumbers setStringValue: [NSString stringWithFormat: @"%@ - ", [pastNumbers stringValue]]];
}
    
- (void)initNumberSequence:(id) sender 
{
	maxOfSeq = [maxNumber intValue];
	if (nums != nil)
		[nums release];
	nums = [[NSMutableArray arrayWithCapacity: maxOfSeq] retain];
	for(int i=0 ; i<maxOfSeq ; i++)
		[nums addObject: [NSNumber numberWithInt: i+1]];
	seq = 0;
	int factor = RAND_MAX / maxOfSeq;
	
	srand((unsigned)time(NULL));
	int repeating = maxOfSeq * 10;
	for( int i=0 ; i<repeating ; i++)	{
		int index1 = rand() / factor;
		int index2 = rand() / factor;
		NSNumber *x1 = [nums objectAtIndex: index1];
		NSNumber *x2 = [nums objectAtIndex: index2];
		[nums replaceObjectAtIndex:index1 withObject:x2];
		[nums replaceObjectAtIndex:index2 withObject:x1];
//	NSLog( @"swap %d %d", index1, index2 );
	}
	[pastNumbers setStringValue: [NSString stringWithFormat: @"Initialized by %d - ", maxOfSeq ]];
	[drawingButton setEnabled: YES];
}

@end
